#include "Cam.h"

Camera::Camera(Vector position) : position(position){
	rotation = Quaternion(1.0, 0, 0, 0);
}

Camera::~Camera(){
}
void Camera::move(Vector v){
	//position = position + attitude * v.z;
	position = position + v;
}

void Camera::rotate(Axis axis, float val){
	Quaternion q;
	switch(axis){
		case AXIS_X:
			q = Quaternion(cosf(val/2.0f), sinf(val/2.0f), 0, 0);
			break;
		case AXIS_Y:
			q = Quaternion(cosf(val/2.0f), 0, sinf(val/2.0f), 0);
			break;
		case AXIS_Z:
			q = Quaternion(cosf(val/2.0f), 0, 0, sinf(val/2.0f));
			break;
		default:
			return;
	}
	rotation = rotation * q;
	rotation.normalize();
}

void Camera::render(){
	float *m = new float[16];
	Quaternion q;
	rotation.conjunction(&q);
	q.createMatrix(m);
	glMultMatrixf(m);
	attitude = Vector(m[2],m[6],m[10]);
	delete[] m;
	glTranslatef(-position.x, -position.y, -position.z);
	//printf("Position: %f, %f, %f\n", position.x, position.y, position.z);
}

void Camera::update(){
}
void Camera::printPos(){
	printf("Position: %f, %f, %f.\n", position.x, position.y, position.z);
}