#include "FireObject.h"


FireObject::FireObject(float x, float y, float z, std::auto_ptr<SDL::OpenGLContext> glContext, char *cfgFile){
	pos = new float[3];
	pos[0] = x;
	pos[1] = y;
	pos[2] = z;
	try {
		//std::string xmlFile("configurations/campfire-3d.xml");
		std::string xmlFile(cfgFile);
		SimpleXml::XmlDocument doc(xmlFile);
		engine = new GpuThesis::Engine(doc, glContext);	
		engine->firstStep();
		//engine->run2();
	
	} catch(const std::exception &e) {
		printf("Error error error.\n");	
		printf(e.what());
		printf("\n");
		exit(1);
	}	
	simulate = true;
}
FireObject::~FireObject(){
}

void FireObject::update(){
	if(simulate){
		engine->simulation();
	}
}
void FireObject::render(){
	glTranslatef(pos[0], pos[1], pos[2]);
	glDisable(GL_DEPTH_TEST);
	engine->visualization();
	
}
void FireObject::calcLOD(){
	//simulate = !simulate;
	engine->calcLOD();
}
