#ifndef _GLOBALS_
#define _GLOBALS_
#include <math.h>
#include <string.h>
#include <sdl.h>
#include <sdl_image.h>
#include <gl/glew.h>
#include <Cg/cg.h>
#include <Cg/cgGL.h>
#include <vector>
#define PI 3.1415926535897932384626433832795029f
#define WIDTH 800
#define HEIGHT 600
typedef unsigned int uint;

#include "Utilities.h"

// Class declarations
class SceneObject{
public:
	virtual ~SceneObject(){};
	virtual void update()=0;
	virtual void render()=0;
	virtual void calcLOD()=0;
};
class StaticObject;
class DynamicObject;
class Camera;
class Light;
class Material;
class Scenegraph;
class Shared;
struct Node;
enum ObjectType{
	STATIC,
	DYNAMIC,
	CAMERA,
	LIGHT,
	FIRE
};
enum Axis{
	AXIS_X,
	AXIS_Y,
	AXIS_Z
};


#endif