#ifndef _SCENEGRAPH_
#define _SCENEGRAPH_
#include "Globals.h"
//#include "Shared.h"
#include "Cam.h"
//#include "Light.h"
#include "StaticObject.h"


namespace OpenGL {
//class Camera;
class CgProgram;
class CgOperation;
class IoTextureSet;
}
class Scenegraph{
private:
	std::vector<Node*> nodes;
	Camera *camera;
	uint nodeCount;
	Shared *shared;
	bool pause, visualizeFire;
	
	bool count;
	int frameCount;
	long int startTime, endTime;
public:
	Scenegraph();
	~Scenegraph();
	void handleInput();
	void update();
	void render();
	void calcLOD();
	void addNode(Node *);
	void setCamera(Camera* camera);
	void startCount();
	void stopCount();
};

struct Node{
	Node(){};
	Node(ObjectType type, SceneObject *object);
	ObjectType type;
	SceneObject *object;
	uint childCount;
	std::vector<Node*> children;
	void addChild(Node *);
	void update();
	void render();
	void calcLOD();
};

#endif