#include "StaticObject.h"

StaticObject::StaticObject(int vc, GLfloat *v, int fc, GLuint *i, GLfloat *n, GLfloat *t, GLfloat *c)
:vertices(v), indices(i), normals(n), texcoords(t), colors(c), vertexCount(vc), faceCount(fc){
	position = Vector(0, 0, 0);
	rotation = Quaternion(1.0f, 0, 0, 0);
	rotMat = new float[16];
	sizex = 1.0f;
	sizey = 1.0f;
	sizez = 1.0f;
}

StaticObject::~StaticObject(){
	printf("Moo\n");
}
void StaticObject::setSize(float x, float y, float z){
	this->sizex = x;
	this->sizey = y;
	this->sizez = z;
}
void StaticObject::render(){
	//glMaterialfv(GL_FRONT, GL_SPECULAR, material->specular);
	//glMaterialfv(GL_FRONT, GL_AMBIENT, material->ambient);
	//glMaterialfv(GL_FRONT, GL_DIFFUSE, material->diffuse);
	//glMaterialfv(GL_FRONT, GL_SHININESS, &material->shininess);
	//glBindTexture(GL_TEXTURE_2D, material->texID);
	glBindBufferARB( GL_ARRAY_BUFFER_ARB, 0 );	
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
	glEnableClientState(GL_NORMAL_ARRAY);
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_COLOR_ARRAY);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);


	glTranslatef(position.x, position.y, position.z);
	rotation.createMatrix(rotMat);
	glMultMatrixf(rotMat);


	glScalef(sizex, sizey, sizez);
	glVertexPointer(3, GL_FLOAT, 0, vertices);
	glNormalPointer(GL_FLOAT, 0, normals);
	glColorPointer(3, GL_FLOAT, 0, colors);
	//glTexCoordPointer(2, GL_FLOAT, 0, texcoords);
	glDrawElements(GL_TRIANGLES, faceCount*3, GL_UNSIGNED_INT, indices);
	//glDrawArrays(GL_TRIANGLES, 0, 25);
}

void StaticObject::setPosition(GLfloat x, GLfloat y, GLfloat z){
	position.x = x;
	position.y = y;
	position.z = z;
}
void StaticObject::rotate(Axis axis, float val){
	Quaternion q;
	switch(axis){
		case AXIS_X:
			q = Quaternion(cosf(val/2.0f), sinf(val/2.0f), 0, 0);
			break;
		case AXIS_Y:
			q = Quaternion(cosf(val/2.0f), 0, sinf(val/2.0f), 0);
			break;
		case AXIS_Z:
			q = Quaternion(cosf(val/2.0f), 0, 0, sinf(val/2.0f));
			break;
		default:
			return;
	}
	rotation = rotation * q;
	rotation.normalize();
}

//void StaticObject::setMaterial(Material *m){
//	this->material = m;
//}

void StaticObject::update(){
	//rotate(AXIS_Y, 0.001f);
}

void StaticObject::calcLOD(){
}