#ifndef _TEXTURETEST_
#define _TEXTURETEST_

#include "Globals.h"
#include "ResourceLoader.h"
#include "gpgpu/FramebufferObject.h"
class Texture2dTest : public SceneObject{
private:
	uint texId[2], active, maxWidth, maxHeight, curWidth, curHeight;
	FramebufferObject *fbo;
	CGprogram resizeProgram, renderProgram;
	CGparameter resizeParameter, renderParameter;
	CGprofile profile;
	CGcontext context;
public:
	Texture2dTest(){};
	Texture2dTest(uint width, uint height);
	~Texture2dTest();

	void calcLOD();
	void calcLod(float lod);
	void resize(float scale);
	void render();
	void swap();
	void update();
};

class Texture3dTest: public SceneObject{
	private:
	uint *texId, active, maxWidth, maxHeight, maxDepth, curWidth, curHeight, curDepth;
	FramebufferObject *fbo;
	CGprogram resizeProgram, renderProgram;
	CGparameter resizeParameter, renderParameter;
	CGprofile profile;
	CGcontext context;
public:
	Texture3dTest(){};
	Texture3dTest(uint width, uint height, uint depth);
	~Texture3dTest();

	void calcLod(float lod);
	void calcLOD();
	void resize(float scale);
	void render();
	void swap();
	void update();
};
#endif