#include <exception>
#include <iostream>
#include <memory>
#include <string>

#include "src/gpu-thesis/Engine.h"

#include "simple-xml/XmlDocument.h"

#include "util/Util.h"
#include "sdl/OpenGLContext.h"
#include "Globals.h"
#include "Cam.h"
#include "Scenegraph.h"
#include "FireObject.h"
#include "StaticObject.h"
#include "ResourceLoader.h"
#include "TextureTest.h"

std::auto_ptr<SDL::OpenGLContext> glContext;
std::auto_ptr<SDL::OpenGLContext> glContext2;
std::auto_ptr<SDL::OpenGLContext> glContext3;
std::auto_ptr<SDL::OpenGLContext> glContext4;
void initOpenGL(){
	//EngineParameters::SetupParams sp = parameters->getSetupParams();

	glContext = Util::autoPtr(new SDL::OpenGLContext(
		640, 480, std::string("Fire!"), false));
	glContext2 = Util::autoPtr(new SDL::OpenGLContext());
	glContext2.get()->screen = glContext.get()->screen;
	glContext3 = Util::autoPtr(new SDL::OpenGLContext());
	glContext3.get()->screen = glContext.get()->screen;
	glContext4 = Util::autoPtr(new SDL::OpenGLContext());
	glContext4.get()->screen = glContext.get()->screen;
	if (!glContext->good()) {
//		console->output("Failed to initialize OpenGL!");
		//throw InitializingOpenGLException();	
		printf("GL context not initialized.\n");
		exit(1);
	}

	//console->output("OpenGL context initialized...");

	if (glewInit() != GLEW_OK) {
	//	console->output("Failed to initialize glew!");
		printf("GLEW not initialized.\n");
		exit(1);
	}

	//console->output("Glew initialized...");

	glViewport(0, 0, WIDTH, HEIGHT);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(75, 640 / static_cast<float>(480), 0.1f, 10000.0f);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glClearColor(0 ,0 ,0 , 1);
	SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	//glCullFace(GL_FRONT);
	glEnable(GL_CULL_FACE);
}

int main(int argc, char** argv) {

	/*std::string xmlFile("configurations/campfire-3d.xml");
	
	if (argc > 1)
		xmlFile = argv[1];
	
	try {

		SimpleXml::XmlDocument doc(xmlFile);

		GpuThesis::Engine engine(doc);		

		return engine.run();
	
	} catch(const std::exception &e) {
		std::cout << "Exception caught: " << e.what() << '\n';		
		return -1;
	}*/
	initOpenGL();

	// Scene initialization
	Scenegraph *scene = new Scenegraph();
	Camera *camera = new Camera(Vector(0,50,100));
	scene->setCamera(camera);

	Node *n;
	StaticObject *o = loadModel("models/sphere.model");
	/*o->setPosition(-25.0f,0,-75.0f);
	o->setSize(50.0f, 50.0f, 50.0f);
	n = new Node(STATIC, o);
	scene->addNode(n);

	o = loadModel("models/monkey.model");
	o->setPosition(50.0f,0,-100.0f);
	o->setSize(50.0f, 50.0f, 50.0f);
	n = new Node(STATIC, o);
	scene->addNode(n);

	n = new Node(STATIC, o);
	o = loadModel("models/thing.model");
	o->setPosition(-50.0f,10.0f,-50.0f);
	o->setSize(25.0f, 25.0f, 25.0f);
	scene->addNode(n);

	o = loadModel("models/thingy.model");
	o->setPosition(-25.0f,0,-80.0f);
	o->setSize(10.0f, 10.0f, 10.0f);
	n = new Node(STATIC, o);
	scene->addNode(n);

	o = loadModel("models/sphere.model");
	o->setPosition(0.0f,0,-50.0f);
	o->setSize(100.0f, 10.0f, 10.0f);
	n = new Node(STATIC, o);
	scene->addNode(n);*/

	/*o = loadModel("models/box.model");
	o->setPosition(0.0f,0,-250.0f);
	o->setSize(500.0f, 75.0f, 25.0f);
	n = new Node(STATIC, o);
	scene->addNode(n);
	o = loadModel("models/box.model");
	o->setPosition(250.0f,0,-250.0f);
	o->setSize(25.0f, 75.0f, 500.0f);
	n = new Node(STATIC, o);
	scene->addNode(n);
	o = loadModel("models/box.model");
	o->setPosition(-250.0f,0,-250.0f);
	o->setSize(25.0f, 75.0f, 500.0f);
	n = new Node(STATIC, o);
	scene->addNode(n);*/

	/*int w = 16;
	int h = 24;
	int d = 16;
	Texture3dTest *t = new Texture3dTest(w,h,d);
	n = new Node(FIRE, t);
	scene->addNode(n);
	t = new Texture3dTest(w,h,d);
	n = new Node(FIRE, t);
	scene->addNode(n);
	t = new Texture3dTest(w,h,d);
	n = new Node(FIRE, t);
	scene->addNode(n);
	t = new Texture3dTest(w,h,d);
	n = new Node(FIRE, t);
	scene->addNode(n);
	t = new Texture3dTest(w,h,d);
	n = new Node(FIRE, t);
	scene->addNode(n);*/

	FireObject *f = new FireObject(0,0,0, glContext, "configurations/fire.xml");
	n = new Node(FIRE, f);
	scene->addNode(n);/*	
	f = new FireObject(60,0,0, glContext2, "configurations/fire.xml");
	n = new Node(FIRE, f);
	scene->addNode(n);/*
	f = new FireObject(20,0,0, glContext3, "configurations/fire.xml");
	n = new Node(FIRE, f);
	scene->addNode(n);/*
	f = new FireObject(75,0,-100, glContext4);
	n = new Node(FIRE, f);
	scene->addNode(n);*/
	
	printf("Scene initialized.\n");
	// Mainloop
	while(true){
		//camera->move(Vector(0,0,0.001f));
		scene->update();;
		scene->render();
	}
	return 0;
}