varying vec4 diffuse,ambientGlobal, ambient;
	varying vec3 normal,lightDir,halfVector, aux;
	varying float dist;
	varying float time;
	
	void main()
	{
		vec3 n,halfV,viewV,ldir;
		float NdotL,NdotHV;
		vec4 color = ambientGlobal;
		float att;
		float val;
		/* a fragment shader can't write a varying variable, hence we need
		a new variable to store the normalized interpolated normal */
		n = normalize(normal);
		val = dot(aux, n);
		/* compute the dot product between normal and normalized lightdir */
		NdotL = max(dot(n,normalize(lightDir)),0.0);
		
		if (NdotL > 0.9) val = 1.0;
		else if (NdotL > 0.7) val = 0.8;
		else if (NdotL > 0.4) val = 0.6;
		else if (NdotL > 0.1) val = 0.4;
		else val = 0.1;
		
		if (NdotL > 0.0) {
		
			att = 1.0 / (gl_LightSource[0].constantAttenuation +
					gl_LightSource[0].linearAttenuation * dist +
					gl_LightSource[0].quadraticAttenuation * dist * dist);
			color += att * (diffuse * NdotL + ambient);
		
			
			halfV = normalize(halfVector);
			NdotHV = max(dot(n,halfV),0.0);
			color += att * gl_FrontMaterial.specular * gl_LightSource[0].specular * 
							pow(NdotHV,gl_FrontMaterial.shininess);
		}
		
		gl_FragColor = color;
		gl_FragColor = vec4(val, val, val, 1.0);
	}